"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/@code-like-a-carpenter/foundation-runtime/src/actions/unmarshall.ts
var unmarshall_exports = {};
__export(unmarshall_exports, {
  unmarshallOptionalField: () => unmarshallOptionalField,
  unmarshallRequiredField: () => unmarshallRequiredField
});
module.exports = __toCommonJS(unmarshall_exports);
var import_assert = require("@code-like-a-carpenter/assert");
var import_errors = require("../errors/index.cjs");
function identity(x) {
  return x;
}
function unmarshallRawRequiredValue(value, columnName, transform) {
  (0, import_assert.assert)(
    value !== null,
    () => new import_errors.DataIntegrityError(`Expected ${columnName} to be non-null`)
  );
  (0, import_assert.assert)(
    typeof value !== "undefined",
    () => new import_errors.DataIntegrityError(`Expected ${columnName} to be defined`)
  );
  return transform(value);
}
function unmarshallRequiredField(item, fieldName, possibleColumnNames, transform = identity) {
  for (const name of possibleColumnNames) {
    if (name in item) {
      return unmarshallRawRequiredValue(item[name], name, transform);
    }
  }
  if (fieldName === "version") {
    return void 0;
  }
  throw new import_errors.DataIntegrityError(`Expected ${fieldName} to be defined`);
}
function unmarshallOptionalField(item, fieldName, possibleColumnNames, transform = identity) {
  for (const name of possibleColumnNames) {
    if (name in item) {
      return transform(item[name]);
    }
  }
  return void 0;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  unmarshallOptionalField,
  unmarshallRequiredField
});
//# sourceMappingURL=unmarshall.cjs.map
