"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/@code-like-a-carpenter/foundation-runtime/src/functions/common/retry.ts
var retry_exports = {};
__export(retry_exports, {
  retry: () => retry
});
module.exports = __toCommonJS(retry_exports);
var import_telemetry = require("@code-like-a-carpenter/telemetry");
var import_errors = require("../../errors/index.cjs");
async function retry(cb) {
  const maxAttempts = 5;
  for (let i = 0; i < maxAttempts; i++) {
    try {
      await (0, import_telemetry.runWithNewSpan)(
        "retry",
        {
          attributes: {
            "com.code-like-a-carpenter.data.attempt": i,
            "com.code-like-a-carpenter.data.total_attempts": maxAttempts
          }
        },
        cb
      );
      return;
    } catch (err) {
      if (err instanceof import_errors.AlreadyExistsError || err instanceof import_errors.OptimisticLockingError) {
        await new Promise(
          (resolve) => setTimeout(resolve, (i + 1) * (1 + 1) * 1e3)
        );
      } else {
        throw err;
      }
    }
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  retry
});
//# sourceMappingURL=retry.cjs.map
