// packages/@code-like-a-carpenter/foundation-runtime/src/errors/optimistic-locking-error.ts
import { BaseDataLibraryError } from "./base-error.mjs";
var OptimisticLockingError = class extends BaseDataLibraryError {
  primaryKey;
  typeName;
  /** constructor */
  constructor(typename, primaryKey) {
    super(
      `${typename} with specified primaryKey is out of date. Please refresh and try again.`,
      { telemetry: { primaryKey, typename } }
    );
    this.primaryKey = primaryKey;
    this.typeName = typename;
  }
};
export {
  OptimisticLockingError
};
//# sourceMappingURL=optimistic-locking-error.mjs.map
