// packages/@code-like-a-carpenter/foundation-runtime/src/functions/table-dispatcher/make-table-dispatcher.ts
import { PutEventsCommand } from "@aws-sdk/client-eventbridge";
import { handleDynamoDBStreamEvent } from "@code-like-a-carpenter/lambda-handlers";
async function handleRecord({ eventBridge, tableName }, record) {
  const modelName = record.dynamodb?.NewImage?._et.S;
  const entry = {
    Detail: JSON.stringify(record),
    DetailType: record.eventName,
    Resources: record.eventSourceARN ? [record.eventSourceARN.split("/stream")[0]] : [],
    Source: [tableName, modelName].join("."),
    Time: record.dynamodb?.ApproximateCreationDateTime ? new Date(record.dynamodb.ApproximateCreationDateTime) : void 0
  };
  await eventBridge.send(
    new PutEventsCommand({
      Entries: [entry]
    })
  );
}
function makeDynamoDBStreamDispatcher(dependencies) {
  return handleDynamoDBStreamEvent(
    async (record) => await handleRecord(dependencies, record),
    dependencies.exceptionTracingService
  );
}
export {
  makeDynamoDBStreamDispatcher
};
//# sourceMappingURL=make-table-dispatcher.mjs.map
