import type { WithExceptionTracing } from '../../dependencies';
import { CDCHandler } from '../common/cdc-handler';
import type { Handler } from '../common/handlers';
import type { UnmarshalledDynamoDBRecord } from '../common/unmarshall-record';
interface SDK<T> {
    unmarshallSourceModel: (item: Record<string, unknown>) => T;
}
/**
 * Makes an SQS handler that expects the payload to be a DynamoDB Stream Record.
 */
export declare function makeReactor<T>(constructor: ReactorConstructor<T>, sdk: SDK<T>, dependencies: WithExceptionTracing): Handler;
export interface ReactorConstructor<T> {
    new (sdk: SDK<T>): Reactor<T>;
}
export declare abstract class Reactor<T> extends CDCHandler {
    sdk: SDK<T>;
    constructor(sdk: SDK<T>);
    react(unmarshalledRecord: UnmarshalledDynamoDBRecord): Promise<void>;
    protected abstract handle(source: T, previous: T | undefined): Promise<void>;
}
export {};
//# sourceMappingURL=make-reactor.d.ts.map